import Fastify from "fastify";
import { Yapper } from "./utils/Yapper";
import { getGrokAuthedCookies } from "./grokCookies";
import { state } from "./utils/state";

export const fastify = Fastify({
	loggerInstance: new Yapper(),
	disableRequestLogging: true
});

fastify.get("/", async (request, reply) => {
	reply.type("text/html");
	return "Hiiiiiii";
});

try {
	state.isRefreshPending = true;
	getGrokAuthedCookies();
	setInterval(() => {
		const {
			expiresIn: { requests, time }
		} = state.grokMeta;

		if ((requests === 0 || time < Date.now()) && !state.isRefreshPending) {
			state.isRefreshPending = true;
			getGrokAuthedCookies();
		}
	}, 500);

	fastify.listen({
		port: parseInt(process.env.PORT || "4935"),
		host: "0.0.0.0"
	});
} catch (err) {
	fastify.log.error(err);
	process.exit(1);
}
